<?php
# +------------------------------------------------------------------+
# |             ____ _               _        __  __ _  __           |
# |            / ___| |__   ___  ___| | __   |  \/  | |/ /           |
# |           | |   | '_ \ / _ \/ __| |/ /   | |\/| | ' /            |
# |           | |___| | | |  __/ (__|   <    | |  | | . \            |
# |            \____|_| |_|\___|\___|_|\_\___|_|  |_|_|\_\           |
# |                                                                  |
# | Copyright Mathias Kettner 2010             mk@mathias-kettner.de |
# +------------------------------------------------------------------+
#
# This file is part of Check_MK.
# The official homepage is at http://mathias-kettner.de/check_mk.
#
# check_mk is free software;  you can redistribute it and/or modify it
# under the  terms of the  GNU General Public License  as published by
# the Free Software Foundation in version 2.  check_mk is  distributed
# in the hope that it will be useful, but WITHOUT ANY WARRANTY;  with-
# out even the implied warranty of  MERCHANTABILITY  or  FITNESS FOR A
# PARTICULAR PURPOSE. See the  GNU General Public License for more de-
# ails.  You should have  received  a copy of the  GNU  General Public
# License along with GNU Make; see the file  COPYING.  If  not,  write
# to the Free Software Foundation, Inc., 51 Franklin St,  Fifth Floor,
# Boston, MA 02110-1301 USA.

setlocale(LC_ALL, "POSIX");

$COLORS = array("#00FFFF", "#00B2EE", "#CD0000", 
                "#2F4F4F", "#2F4F4F", "#330000",
                "#007FFF", "#4372AA", "#FF3300",
                "#3232CD", "#191970", "#FF7D40");

$servicename = preg_replace("/\./", " ", $servicedesc, 1);
$service = preg_split("/ /", $servicename);
$device = $service[1];

$ds_name[1] = "PowerPath Path Statistics (Latency)";
$opt[1] = "--vertical-label '$device' -l 0  --title '$hostname / $servicename (Latency)' ";
$def[1] = "";
for (reset($NAME); current($NAME); next($NAME)) {
    $path_name = strstr(strstr(current($NAME), $device), "_latency", true);
    if ($path_name) {
        $key = key($NAME);
        $path = str_replace(":", "_", substr($path_name, strlen($device)+1));
        $color = $COLORS[$key-1];
        $def[1] .= "DEF:$path=$RRDFILE[1]:$DS[$key]:MAX ";
        $def[1] .= "CDEF:ms_$path=$path,1000,/ ";
        $def[1] .= "LINE2:ms_$path$color:$path ";
        $def[1] .= "GPRINT:ms_$path:LAST:\"current\: %.2lf (ms)\" ";
        $def[1] .= "GPRINT:ms_$path:AVERAGE:\"avg\: %.2lf (ms)\" ";
        $def[1] .= "GPRINT:ms_$path:MAX:\"max\: %.2lf (ms)\\n\" ";
    }
}

$ds_name[2] = "PowerPath Path Statistics (Queued IOs)";
$opt[2] = "--vertical-label '$device' -l 0  --title '$hostname / $servicename (Queued IOs)' ";
$def[2] = "";
for (reset($NAME); current($NAME); next($NAME)) {
    $path_name = strstr(strstr(current($NAME), $device), "_queued_ios", true);
    if ($path_name) {
        $key = key($NAME);
        $path = str_replace(":", "_", substr($path_name, strlen($device)+1));
        $color = $COLORS[$key-1];
        $def[2] .= "DEF:$path=$RRDFILE[1]:$DS[$key]:MAX ";
        $def[2] .= "LINE2:$path$color:$path ";
        $def[2] .= "GPRINT:$path:LAST:\"current\: %.0lf\" ";
        $def[2] .= "GPRINT:$path:AVERAGE:\"avg\: %.0lf\" ";
        $def[2] .= "GPRINT:$path:MAX:\"max\: %.0lf\\n\" ";
    }
}

$ds_name[3] = "PowerPath Path Statistics (Errors)";
$opt[3] = "--vertical-label '$device' -l 0  --title '$hostname / $servicename (Errors)' ";
$def[3] = "";
for (reset($NAME); current($NAME); next($NAME)) {
    $path_name = strstr(strstr(current($NAME), $device), "_errors", true);
    if ($path_name) {
        $key = key($NAME);
        $path = str_replace(":", "_", substr($path_name, strlen($device)+1));
        $color = $COLORS[$key-1];
        $def[3] .= "DEF:$path=$RRDFILE[1]:$DS[$key]:MAX ";
        $def[3] .= "CDEF:ms_$path=$path,1000,/ ";
        $def[3] .= "LINE2:ms_$path$color:$path ";
        $def[3] .= "GPRINT:ms_$path:LAST:\"current\: %.0lf\" ";
        $def[3] .= "GPRINT:ms_$path:AVERAGE:\"avg\: %.0lf\" ";
        $def[3] .= "GPRINT:ms_$path:MAX:\"max\: %.0lf\\n\" ";
    }
}

?>
